<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: object_history.php,v 1.8 2003/10/07 21:21:14 vollmerk Exp $
 $Source: /data/cvsroot/maintain/modules/class/object_history.php,v $

 The object history object.  Given a object type and id you can get
   information about what has happened with that type/id combo.

*/

class ObjectHistory {
	var $id;
	var $username; 
	var $object_type;
	var $object_id;
	var $date;
	var $comment;

	function ObjectHistory ( $object_type, $object_id ) {
		global $conf;

		if ( (! $object_type) AND (! $object_id) ) {
			return;
		}

		$this->object_type   = $object_type;
		$this->object_id     = $object_id;

		return false;

	} // object_history

	// Just return a specific object history item
	//   
	function get_history () {
		global $conf;

		$sql = "SELECT * FROM object_history 
                        WHERE object_id='$this->object_id' AND 
			object_type='$this->object_type' ORDER BY date DESC LIMIT 1";
		$db_result = mysql_query($sql, $conf['dbh']);

		return mysql_fetch_object($db_result);
	}

	/*!
		@function get_all_history
		@discussion gets all of the historical data for an object and
			returns it in an array
	*/
	function get_all_history() {
		global $conf;

		$sql = "SELECT * FROM object_history
			WHERE object_id='$this->object_id' AND
			object_type='$this->object_type' ORDER BY date DESC";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) {
			$results[] = $r;
		}

		return $results;
	} // get_all_history

	/*!
		@function get_zone_history
		@discussion this only works on zones, but it grabs all 
			the deletion records, and trys to get everything
			else as well.. kinda slow :S
	*/
	function get_zone_history() {
		
		
		// First let's get the deleted records
		$sql = "SELECT * FROM object_history WHERE object_type='delete' AND object_id='$this->object_id'";
		$sql .= " ORDER BY object_history.date DESC";
		$db_results = mysql_query($sql, dbh());

		while ($r = mysql_fetch_object($db_results)) {
			$results->delete[] = $r;
		}


		// Second let's collect the hosts.. this is a littler harder
		$sql = "SELECT host.id FROM object_history,host WHERE host.id=object_history.object_id AND object_history.object_type='host' AND host.zone='$this->object_id'";
		$sql .= " ORDER BY object_history.date DESC";
		$db_results = mysql_query($sql, dbh());

		while ($r = mysql_fetch_object($db_results)) {
			$host = new Host($r->id);
			$host->history = $host->object_history->get_history();
			$results->host[] = $host;
		}

		// These are cnames
		$sql = "SELECT zone_cname.id FROM object_history,zone_cname WHERE object_history.object_type='cname' AND object_history.object_id=zone_cname.id AND  zone_cname.zone='$this->object_id'";
		$sql .=" ORDER BY object_history.date DESC";
		$db_results = mysql_query($sql, dbh());
		
		while ($r = mysql_fetch_object($db_results)) {
			$cname = new Cname($r->id);
			$cname->history = $cname->object_history->get_history();
			$results->cnames[] = $cname;
		}

		// Next let's get the mx records
		$sql = "SELECT zone_mx.id FROM object_history,zone_mx WHERE object_history.object_type='mx' AND object_history.object_id=zone_mx.id AND zone_mx.zone='$this->object_id'";
		$sql .= " ORDER BY object_history.date DESC";
		$db_results = mysql_query($sql, dbh());

		while ($r = mysql_fetch_object($db_results)) {
			$mx = new MX($r->id);
			$mx->history = $mx->object_history->get_history();
			$results->mxs[] = $mx;
		}

		
		return $results;


	} // get_zone_history

	// Get how many object history entries we have for this
	//   host.
	function get_count () {
		global $conf;

		$sql = "SELECT count(*) FROM object_history
			WHERE object_type='$this->object_type'
			AND object_id='$this->object_id'";

		$db_result = mysql_query($sql, $conf['dbh']);

		$count = mysql_fetch_row($db_result);
		return $count[0];
	}

	// Just insert a object_history row
	function insert ($username,$object_type,$object_id,$date,$comment) {
		global $conf;

		$sql = "INSERT INTO object_history (username,object_type,object_id,date,comment) 
			VALUES ('$username', '$object_type', $object_id, $date, '$comment')";
		$db_result = mysql_query($sql, $conf['dbh']);
	}

	// With update we are actually just going to do an insert ... we'll never change
	//  any old host history information
	function update ($username,$comment = 0) {
		global $conf;

		$this->insert($username,$this->object_type,$this->object_id,time(),$comment);
	}

	function delete ($id) {
	        global $conf;

                $sql = "DELETE FROM object_history WHERE id='$id'";
                $db_result = mysql_query($sql, $conf['dbh']);
	}

	function delete_all () {
		$all = $this->get_all_history();

		while ( $history = each ($all)) {
			$this->delete($history->id);
		}
	}

}

?>
