<?php

/*

 $Id: show_cname.inc,v 1.37 2004/03/19 23:04:58 philips Exp $
 $Source: /data/cvsroot/maintain/templates/show_cname.inc,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Display Cname Template
	Template for viewing/editing a single cname record

*/

// for those who don't have a zone set
if ($cname->id) { $domains = $cname->zone->domains(); }

$history = $cname->object_history->get_history();

?>
<? $conf['help']->display_help('cname_general'); ?>
<? echo "<p>"; $conf['error']->show_message('general'); echo "</p>"; ?>
<? 
$items = array();
if ($user->has_access($cname->zone->id)) { 
	$items[] = "<a href=\"" . $conf['web_path'] . "/cname.php?action=show_cname&cname_id=" . $cname->id ."\">Edit</a>";
	$items[] = "<a href=\"" . $conf['web_path'] . "/cname.php?action=delete&cname_id=" . $cname->id . "\">Delete</a>";
	$items[] = "<a href=\"" . $conf['web_path'] . "/create_cname.php\">Create New CNAME</a>";
} 
$items[] = "<a href=\"" . $conf['web_path'] . "/cname.php?action=show_cnames\">Show Cnames</a>";
$conf['ui']->display_top_widget($items);
?>
<? if ($action_type) { ?>
<p><font class="header2">
<? 
if ($action_type == "modified") { echo "Updated $cname->hostname with the following information"; }
elseif ($action_type == "read") { echo "Viewing CNAME information for $cname->hostname"; } 
?>
</font>
&nbsp;&nbsp;



</p>
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%" bgcolor="<?= $conf['color']->bg['light_bgcolor']?>">
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td>CNAME Build Status:</td>
		<td>
		<?= $conf['ui']->show_live_time($history->date,"CNAME"); ?>
		</td>
	</tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" width="100%">
                <td title="<? $conf['help']->title('cname'); ?>"><? $conf['help']->show_link('cname'); ?>CNAME: </td>
                <td><? $conf['ui']->display_field($cname->name) ?>
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('domain'); ?>"><? $conf['help']->show_link('cname_domain'); ?>Domain: </td>
                <td><? $conf['ui']->display_field($cname->domain->name); ?>
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('cname_server'); ?>"><? $conf['help']->show_link('cname_server'); ?>Server Name: </td>
                <td align="left"><? $conf['ui']->display_field($cname->server); ?></td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<? if ($cname->ttl < 300) { $cname->ttl = $conf['default_cname_ttl']; } ?>
		<td title="<? $conf['help']->title('ttl'); ?>"><? $conf['help']->show_link('ttl'); ?>TTL:</td>
		<td><? $conf['ui']->display_field($cname->ttl); ?></td>
	</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('parent_zone'); ?>"><? $conf['help']->show_link('parent_zone'); ?>Parent Zone: </td>
		<td><? $conf['ui']->display_field($cname->zone->name); ?></td>
	</tr>	
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title("generic_comment"); ?>"><? $conf['help']->show_link("generic_comment"); ?>Comment: </td>
		<td><? $conf['ui']->display_field($history->comment); ?></td>
	</tr>	
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('who_update'); ?>"><? $conf['help']->show_link('who_update'); ?>Last Updated By: </td>
		<td>
                <? if ($history->username) { ?>
                        <? $conf['ui']->display_field($history->username); ?><?= " on " . date("F j, Y",$history->date) . " at " . date("g:i a",$history->date); ?>
                <? } else { ?>
                        N/A
                <? } ?>
		</td>
	</tr>	

</table>
<? show_template('bborder'); ?>
<? 
} //view cname

/********************
  EDITING THE CNAME 
********************/

//Edit the cname
else { 
?>

<form name="edit_cname" enctype="multipart/form-data" style="Display:inline" method="post" action="<?= $conf['web_path']; ?>/cname.php">
<input type="hidden" name="cname_id" value="<? echo $cname->id ?>" />
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr>
	<td colspan="2" class="widget-title">Editing CNAME information for <?= $cname->hostname; ?></td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>CNAME Build Status:</td>
	<td><?= $conf['ui']->show_live_time($history->date,"CNAME"); ?></td>
</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" width="100%">
    		<td title="<? $conf['help']->title("cname"); ?>"><? $conf['help']->show_link('cname'); ?> CNAME: </td>
                <td>
			<? if ($cname->zone->has_domain_access($cname->domain->id) or $user->is_admin) { ?>
	                        <input type="textbox" name="name" value="<?= $cname->name ?>" size="35" />
				<? $conf['error']->show_message('name'); ?>
			<? } else { ?>
				<? echo $cname->name; ?>
				<input type="hidden" name="name" value="<?= $cname->name; ?>" />
			<? } ?>
                </td>
	</tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('cname_domain'); ?>"><? $conf['help']->show_link('cname_domain'); ?>Domain: </td>
                <td><? if ($user->is_admin) { ?><input type="radio" onclick="enableField('domain_id');disableField('admin_domain_id');" name="domain_select" value="user" CHECKED /><? } ?>
			<? 
			if ($cname->zone->has_domain_access($cname->domain->id)) { 
				$conf['ui']->show_domain_select($domains, $cname->domain->id); 
			}
			else { 
				$domains[] = new Domain($cname->domain->id);
				$conf['ui']->show_domain_select($domains, $cname->domain->id);
				echo "<font class=\"error\">Current domain not in " . $cname->zone->name . "</font>";
			}
			?>
                </td>
        </tr>
        <? if ($user->is_admin) { ?>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title("domain"); ?>"><? $conf['help']->show_link("domain"); ?> Admin Domains: </td>
                <td><input type="radio" onclick="enableField('admin_domain_id');disableField('domain_id');" name="domain_select" value="admin" />
                <?
                //if they are a admin allow them to movie it anywhere!
                $admin_domains = $conf['ui']->get_domains("SELECT * FROM domain ORDER BY name ASC");
                $conf['ui']->show_domain_select($admin_domains, $cname->domain->id,"admin_domain_id",'disabled');
                ?>
                </td>
        </tr>
        <? } ?>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('cname_server'); ?>"><? $conf['help']->show_link('cname_server'); ?>Server Name: </td>
                <td>
                        <input name="server" value="<?= $cname->server ?>" size="35" />
			<? $conf['error']->show_message('server'); ?>
		</td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('ttl'); ?>"><? $conf['help']->show_link('ttl'); ?>TTL:</td>
                <td>
			<? if (!$cname->ttl) { $cname->ttl = $conf['default_cname_ttl']; } ?>
			<input name="ttl" value="<?= $cname->ttl; ?>" size="35" />
			<? $conf['error']->show_message('ttl'); ?>
		</td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('generic_comment'); ?>" valign="top"><? $conf['help']->show_link('generic_comment'); ?>
                        Comment:
                        <a href="<?= $conf['web_path']; ?>/help.php?action=show_comments&amp;object_id=<?= $cname->id; ?>&amp;object_name=<?= $cname->hostname; ?>&amp;object_type=cname">
                        [View All Comments]
                        </a>
                </td>
                <td>
                <textarea name="comment" cols="45" rows="5"><?= $history->comment; ?></textarea>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('parent_zone'); ?>"><? $conf['help']->show_link('parent_zone'); ?> Parent Zone: </td>
		<td><? $conf['ui']->display_field($cname->zone->name); ?></td>
	</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('who_update'); ?>"><? $conf['help']->show_link('who_update'); ?>Last Updated By: </td>
		<td>
                <? if ($history->username) { ?>
                        <? $conf['ui']->display_field($history->username); ?><?= " on " . date("F j, Y",$history->date) . " at " . date("g:i a",$history->date); ?>
                <? } else { ?>
                        N/A
                <? } ?>
		</td>
	</tr>	
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td colspan="2" align="center">
			<? if ( $user->has_access($cname->zone->id) ) { ?>
			<input type="submit" name="action" value="Update" />
			<input type="submit" name="action" value="Delete" />
			<input type="submit" name="action" value="Cancel" />
			<input type="hidden" name="last_update" value="<?= $history->date; ?>" />
			<? } else { ?>
			<input type="submit" name="action" value="Return" />
			<? } ?>
		</td>
	</tr>
</table>
<? show_template('bborder'); ?>
</form>
<? if ($user->is_admin) { ?>
<p class="header2">Move the CNAME <?= $cname->hostname; ?> to another Zone.</p>
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%" bgcolor="<?= $conf['light_bgcolor']; ?>">
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>"> 
	<td>Move <?= $cname->hostname; ?> to.</td>
	<td>
	<form method="post" style="Display:inline" enctype="multipart/form-data" action="<?= $conf['web_path']; ?>/cname.php">
	<input type="hidden" name="action" value="confirm_move" />
	<input type="hidden" name="cname_id" value="<?= $cname->id; ?>" />
	<? // zone list mojo time!
	$zones = $user->zones(); 
	$conf['ui']->show_zone_select($zones,$zones[0],"zone_id");
	?>
	</td>
	<td>
	<input type="submit" value="Move CNAME" />
	</form>
	</td>
	</tr>
</table>


<? show_template('bborder'); ?>
<? } ?>
<? } ?>
