<?php

/*

 $Id: show_range.inc,v 1.27 2004/06/29 19:33:46 philips Exp $
 $Source: /data/cvsroot/maintain/templates/show_range.inc,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Show Range Template
	This tools consists of two parts

	Part A) Displays the Range

	Part B) Displays the Zone to Range Mappings

*/

// we'll need these later
// we need to run through and make zone objects for show_zone_select
// there is a chance an brand new/unused range will not have any zones assoicated with it
if ($range->zones) { 
	foreach ($range->zones as $zone) {
		$zones[] = new Zone($zone);
	}
}


// we need all the domains, right?!
$domain = new Domain(0);
$domains = $domain->domains();

?>

<? if ( $action == 'show_create' ) { 
	$current_operation = "Create a new IP Range";
	} 
else { 
	$current_operation = "Update a IP Range";
	} 
?>

<? if ( $conf['error']->get_status('range_top') ) { ?>
<p><? $conf['error']->show_message('range_top'); ?></p>
<? } ?>

<?
/* Setup the Widget for Extra Commands for this Range */

$items[] = "<a href=\"" . $conf['web_path'] . "/range.php?action=show_create\">Create New Range</a>";
$items[] = "<a href=\"" . $conf['web_path'] . "/range.php?action=show_ranges\">View All Ranges</a>";
$items[] = "<a href=\"" . $conf['web_path'] . "/range.php?action=show_unused_ranges\">View Unused Ranges</a>";
$conf['ui']->display_top_widget($items);

?>
<form name="edit_range" enctype="multipart/form-data" method="post" action="<?= $conf['web_path']; ?>/range.php" style="Display:inline">
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
	<tr class="widget-title">
		<td colspan="2"><?= $current_operation; ?></td>
	</tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('ip_range'); ?>"><? $conf['help']->show_link('ip_range'); ?> IP Range Start: </td>
                <td><input name="ip_start" value="<?= $range->start->ip_addr ?>" size="18" maxlength="15" />
		<? $conf['error']->show_message('range_ip_start'); ?>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('ip_range'); ?>"><? $conf['help']->show_link('ip_range'); ?> IP Range End: </td>
                <td><input name="ip_end" value="<?= $range->end->ip_addr ?>" size="18" maxlength="15" />
		<? $conf['error']->show_message('range_ip_end'); ?>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('range_enabled'); ?>"><? $conf['help']->show_help_link('range_enabled'); ?> Enabled:</td>
		<td>
			<select name="enabled">
				<option value="1" <? if ($range->is_enabled()) { echo "SELECTED"; } ?> >Enabled</option>
				<option value="0" <? if (!$range->is_enabled()) { echo "SELECTED"; } ?> >Disabled</option>
			</select>
		</td>
	</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('ip_range'); ?>"><? $conf['help']->show_link('ip_range'); ?> Select Range Type: </td>
                <td>
			<select name="type" onchange="this.form.allow_all_hosts.disabled = this.selectedIndex == 1;">
				<option value="dynamic" <? if ($range->type == 'dynamic') { echo "SELECTED"; } ?>>Dynamic</option>
				<option value="static" <? if ($range->type == 'static') { echo "SELECTED"; } ?>>Static</option>
			</select>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('allow_all_hosts'); ?>"><? $conf['help']->show_link('allow_all_hosts'); ?> Allow any registered host in dynamic pool: </td>
                <td>
			<select name="allow_all_hosts" <? if ($range->type == 'static') { echo "disabled"; } ?>>
				<option value="0" <? if (!$range->allow_all_hosts) {echo "SELECTED";} ?>>No</option>
				<option value="1" <? if ($range->allow_all_hosts) {echo "SELECTED";} ?>>Yes</option>
			</select>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('range_comment'); ?>" valign="top">Comment: </td>
                <td valign="top">
			<textarea cols="50" rows="15" name="comment"><?= $range->comment; ?></textarea>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td>&nbsp;</td>
		<td>
		<? if ( $action == 'show_create' ) { ?>
			<input type="submit" name="action" value="Create" />&nbsp;&nbsp;
			<input type="submit" name="action" value="Cancel" />
		<? } else { ?>
			<input type="submit" name="action" value="Update" />&nbsp;&nbsp;
			<input type="submit" name="action" value="Delete" />&nbsp;&nbsp;
			<input type="submit" name="action" value="Cancel" />
			<input type="hidden" name="range_id" value="<?= $range->id ?>" />
		<? } ?>
		</td>
	</tr>
</table>
<? show_template('bborder'); ?>
</form>
<br /><br />
<?
/**************************
 Part B) Range Mapping Mojo
**************************/
if ($action !== 'show_create') {
?>
<p class="header2">Range to Zone Mappings</p>
<p><? $conf['help']->display_help("zone_range_general"); ?></p>

<form name="view_zone_range" enctype="multipart/form-data" method="post" action="<?= $conf['web_path']; ?>/range.php" style="Display:inline">
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr class="widget-title" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" align="center">
	<td>Zone</td>
	<td>Range</td>
	<td>Default Domain</td>
	<td>Status</td>
	<td>Action</td>
</tr>
<? 
if ($zones) { 

	foreach ($zones as $zone) { 

	//check to see if it's enabled if now we give the tr a different class
	$enabled = $range->zone_is_enabled($zone->id); 

	//get the default domain
	$domain = new Domain($range->get_default_domain($zone->id));
?>

<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" align="center">
	<td><?= $conf['ui']->display_field($zone->name); ?></td>
	<td><?= $conf['ui']->display_field($range->start->ip_addr . " - " . $range->end->ip_addr); ?></td>
	<td><?= $conf['ui']->display_field($domain->name); ?></td>
	<td>
	<? 
	if ($enabled) { echo "Enabled"; }
	else { echo "Disabled"; }
	?>
	</td>
	<td>
	<a href="<?= $conf['web_path']; ?>/range.php?action=confirm_delete_zone_range&amp;zone_id=<?= $zone->id; ?>&amp;range_id=<?= $range->id; ?>" >Delete</a> |  
	<? if ($enabled) { ?>
		<a href="<?= $conf['web_path']; ?>/range.php?action=enable_zone_range&amp;zone_id=<?= $zone->id; ?>&amp;range_id=<?= $range->id; ?>&amp;enabled=0" >Disable</a>
	<? } else { ?>
		<a href="<?= $conf['web_path']; ?>/range.php?action=enable_zone_range&amp;zone_id=<?= $zone->id; ?>&amp;range_id=<?= $range->id; ?>&amp;enabled=1" >Enable</a>
	<? } ?>
	</td>
</tr>
<? 
	} //end foreach 
} //end if zones
else { ?>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" align="center">
	<td colspan="5"><font class="fatalerror">Error: This Range is currently not assoicated with any Zones</font></td>
</tr>
<? } // end else ?>
</table>
<? show_template('bborder'); ?>
</form>

<? 
if ($_REQUEST['action'] != "show_create" && $range->id) { 
?>
<br /><br />



<? if ( $conf['error']->get_status('zone_range_top') ) { ?>
<p><? $conf['error']->show_message('zone_range_top'); ?></p>
<? } ?>

<form name="add_zone_range" enctype="multipart/form-data" method="post" action="<?= $conf['web_path']; ?>/range.php" style="Display:inline">
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr class="widget-title" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td colspan="2">Add this Range to a Zone</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>Zone:</td>
	<td>
        <? $all_zones = $conf['ui']->get_zones("SELECT * FROM zone ORDER BY zone.name"); $conf['ui']->show_zone_select($all_zones, $all_zones[0]); ?>
	</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>Default Domain:</td>
	<td>
	<? $domains = $conf['ui']->get_domains("SELECT * FROM domain ORDER BY domain.name"); $conf['ui']->show_domain_select($domains,$domains[0]); ?>
	</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>Require All Domains in Zone</td>
	<td><input type="checkbox" name="check_source_domain" /></td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>&nbsp;</td>
	<td>
	<input type="submit" value="Add Range" />&nbsp;&nbsp;&nbsp;
	<input type="hidden" name="range_id" value="<?= $range->id; ?>" />
	<input type="hidden" name="action" value="add_zone_range" />
	<input type="submit" name="action" value="Cancel" />
	</td>
</tr>
</table>
<? show_template('bborder'); ?>
</form>
<? } ?>
<? } ?>

